import java.util.Collection;
import java.util.Iterator;
import java.util.Set;
import java.util.SortedMap;
import java.util.SortedSet;
import java.util.StringTokenizer;
import java.util.TreeMap;
import java.util.TreeSet;


public class IndiceSignificativas {
	private String separadores;
	private TreeMap<String, Set<Titulo>>indice;
	private Collection<String> nosig;
	
	public IndiceSignificativas(String sep, Collection<String> ns){
		if(sep != null && sep.length()>0){
			separadores = sep;
			indice = new TreeMap<String, Set<Titulo>>();
			nosig = ns;
		}else{
			throw new IllegalArgumentException("Bad programming");
		}
	}
	
	public IndiceSignificativas(String sep, Collection fras, Collection<String> ns){
		this(sep, ns);
		agregarTitulos(fras);
	}
	
	public void agregarTitulo(String t){
		StringTokenizer st = new StringTokenizer(t, " ");
		while(st.hasMoreTokens()){
			String aux = st.nextToken();
			Titulo taux = new Titulo(t);
			if(!nosig.contains(aux.toLowerCase())){	
				if(!indice.containsKey(aux)){
					Set<Titulo> conjunto = new TreeSet<Titulo>();
					indice.put(aux,conjunto);
				}
				indice.get(aux).add(new Titulo(taux.replace(aux)));
			}
		}
	}
	
	public void agregarTitulos(Collection<String>colTit){
		for (String t : colTit){
			agregarTitulo(t);
		}
	}
	
	public String presentaIndice(){
		String l= "";
		Set s = indice.keySet();
		Iterator ik = s.iterator();
		Collection c= indice.values();
		Iterator iv = c.iterator();
		while(ik.hasNext()){
			l+= ik.next().toString().toUpperCase()+" ";
			l += "\r";
			StringTokenizer st = new StringTokenizer(iv.next().toString(), ",");
			while(st.hasMoreTokens()){
				l+= (st.nextToken());
				l+="\r";
			}
			l += "\n";
		}
		return l;
	}

}